package com.example.kamizelka;

import android.app.Activity;
import android.bluetooth.le.BluetoothLeScanner;
import android.bluetooth.le.ScanCallback;
import android.bluetooth.le.ScanResult;
import android.os.Handler;
import android.util.Log;
import android.widget.Toast;

public class BluetoothLEServiceScanner extends BluetoothLeService{
    private boolean scanning;
    private final static int SCAN_PERIOD = 10000;                                           // Период сканирования 10 с.
    private final BluetoothLeScanner bluetoothLeScanner;
    BluetoothLEServiceConnecter connecter;

    protected final static String TAG = "BLUETOOTH SCANNER";

    public BluetoothLEServiceScanner(Activity active) {
        super(active);
        this.bluetoothLeScanner = bluetoothAdapter.getBluetoothLeScanner();
        if(bluetoothLeScanner == null) Toast.makeText(active, R.string.blu_not_supported_sc, Toast.LENGTH_LONG).show();
        this.scanning = false;
    }

    public void scanLeDevice(DeviceListDialog dialogfragment, BluetoothLEServiceConnecter connecter) {
        this.connecter = connecter;
        connecter.dialogfragment = dialogfragment;
        if (!scanning) {
            new Handler().postDelayed(new Runnable() {
                @Override
                public void run() {                                                     // Останавливаем сканирование через определённое время.
                    Log.d(TAG, "Stop scanning\n");
                    scanning = false;
                    bluetoothLeScanner.stopScan(leScanCallback);
                    connecter.scanReady();
                }}, SCAN_PERIOD);
            scanning = true;
            bluetoothLeScanner.startScan(leScanCallback);
    }}

    private final ScanCallback leScanCallback = new ScanCallback() {              // Device scan callback.
        @Override
        public void onScanResult(int callbackType, ScanResult result) {     // Сохраняем все устройства с именем remoteDeviceName.
            super.onScanResult(callbackType, result);
            if(result.getDevice().getName() != null && result.getDevice().getName().equals(DeviceHolder.remoteDeviceName))
                if(!connecter.remoteDeviceAddresses.contains(result.getDevice().getAddress()))
                    connecter.remoteDeviceAddresses.add(result.getDevice().getAddress());
        }};
    public void delete() throws Throwable {
        bluetoothLeScanner.stopScan(leScanCallback);
        this.finalize();
    }
}
