package com.example.kamizelka;

import android.app.Activity;
import android.app.Service;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothGattCharacteristic;
import android.bluetooth.BluetoothGattDescriptor;
import android.bluetooth.BluetoothManager;
import android.content.Context;
import android.content.Intent;
import android.os.Binder;
import android.os.IBinder;
import android.util.Log;
import android.widget.Toast;

public class BluetoothLeService extends Service{
    protected final IBinder binder = new LocalBinder();
    protected static BluetoothAdapter bluetoothAdapter = null;
    private static final int REQUEST_ENABLE_BT = 1;

    public BluetoothLeService(Activity active) {
        BluetoothManager bluetoothManager = (BluetoothManager) active.getSystemService(Context.BLUETOOTH_SERVICE);
        if(bluetoothManager == null) {
            Toast.makeText(active, R.string.ble_not_supported_bm, Toast.LENGTH_LONG).show();
            return;
        }
        bluetoothAdapter = bluetoothManager.getAdapter();
        if(bluetoothAdapter == null){
            Toast.makeText(active, R.string.blu_not_supported_ba, Toast.LENGTH_LONG).show();
            return;
        }
        if(!bluetoothAdapter.isEnabled()){
            Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            active.startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
        }
    }

     public class LocalBinder extends Binder {
        BluetoothLeService getService() {
            Log.d("BLUETOOTH", "getService");
            return BluetoothLeService.this;
        }}

    @Override
    public IBinder onBind(Intent intent) {
        Log.d("BLUETOOTH", "onBind");
        return binder;
    }

}
