package com.example.kamizelka;

import java.io.ByteArrayOutputStream;
import java.nio.charset.StandardCharsets;

public class DeviceHolder {
    public String addressRight;
    public String addressLeft;
    public String serialNumber;
    public String channel;
    public String author;
    public String technicalImplementation;
    public String deviceVersion;
    public String deviceName;
    public String transferDevice;
    public String playerDevice;
    public String leftChannelDevice;
    public String ready;
    public static final String serialNumberCharacteristicUUID = "58476dd1-cc53-4ae0-9a84-05c0c0e02419";
    public static final String channelCharacteristicUUID = "58476dd3-cc53-4ae0-9a84-05c0c0e02419";
    public static final String authorCharacteristicUUID = "58476dd5-cc53-4ae0-9a84-05c0c0e02419";
    public static final String technicalImplementationCharacteristicUUID = "58476dd7-cc53-4ae0-9a84-05c0c0e02419";
    public static final String deviceVersionCharacteristicUUID = "58476dd9-cc53-4ae0-9a84-05c0c0e02419";
    public static final String deviceNameCharacteristicUUID = "58476ddb-cc53-4ae0-9a84-05c0c0e02419";
    public static final String dataServiceUUID = "07803df7-c740-4c4b-b7a5-bae89e59a0f2";
    public static final String dataCharacteristicUUID = "07803df8-c740-4c4b-b7a5-bae89e59a0f2" ;
    public static final String transferCharacteristicUUID = "07803dfb-c740-4c4b-b7a5-bae89e59a0f2";
    public static final String playerCharacteristicUUID = "07803dfd-c740-4c4b-b7a5-bae89e59a0f2";
    public static final String leftChannelCharacteristicUUID = "07803df5-c740-4c4b-b7a5-bae89e59a0f2";
    public static final String readyCharacteristicUUID = "07803df3-c740-4c4b-b7a5-bae89e59a0f2";
    public static final String remoteDeviceName = "Kamizelka"; //"ESP_GATTS_DEMO"
//    private final static String kamizelkaInfoServiceUUID = "000000FF-0000-1000-8000-00805F9B34FB";
    public DeviceHolder(String addressRight){
        this.addressRight = addressRight;
        this.addressLeft = null;
    }

    public void setValues(String string, final byte[] data){
        if(string.equals(DeviceHolder.serialNumberCharacteristicUUID))
            this.serialNumber = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.channelCharacteristicUUID))
            this.channel = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.authorCharacteristicUUID))
            this.author = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.technicalImplementationCharacteristicUUID))
            this.technicalImplementation = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.deviceVersionCharacteristicUUID))
            this.deviceVersion = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.deviceNameCharacteristicUUID))
            this.deviceName = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.transferCharacteristicUUID))
            this.transferDevice = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.playerCharacteristicUUID))
            this.playerDevice = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.leftChannelCharacteristicUUID))
            this.leftChannelDevice = manageCharacteristicValue(data);
        if(string.equals(DeviceHolder.readyCharacteristicUUID))
            this.ready = manageCharacteristicValue(data);
    }
    public static String manageCharacteristicValue(final byte[] data) {
        if (data != null && data.length > 0) {
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            for (byte datum : data) {
                baos.write(datum);
            }
            return new String(baos.toByteArray(), StandardCharsets.UTF_8);
        }
        return "Undefined characteristic";
    }
}
