package com.example.kamizelka;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Build;
import android.os.Bundle;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatDialogFragment;
import androidx.fragment.app.FragmentManager;

import java.util.ArrayList;

public class DeviceListDialog extends AppCompatDialogFragment {

    private final ArrayList<DeviceHolder> deviceHolders = new ArrayList<>();
    private final ArrayList<String> addressList = new ArrayList<>();
    private final ArrayList<Boolean> checkedItemsList = new ArrayList<>();
    private final FragmentManager fragmentManager;
    private String dialogTitle = "";
//    BluetoothLEServiceSenderFile senderFile;
//    BluetoothLEServiceSenderMic senderMic;
BluetoothLEServiceSender sender;

    public DeviceListDialog(FragmentManager fragmentManager, BluetoothLEServiceSender sender){
        this.fragmentManager = fragmentManager;
//        this.senderFile = senderFile;
//        this.senderMic = senderMic;
        this.sender = sender;
    }

    public FragmentManager getfManager(){
        return this.fragmentManager;
    }

    public void show(){
        this.show(fragmentManager, "DeviceListDialog");
    }

    public void switchDialogTitle(){
        this.dialogTitle = getResources().getString(R.string.connect_button_choose);
    }

    public void addItem(String string, DeviceHolder deviceHolder){
        this.addressList.add(string);
        this.checkedItemsList.add(false);
        this.deviceHolders.add(deviceHolder);
        this.dismiss();
    }

    @NonNull
    @Override
    @RequiresApi(api = Build.VERSION_CODES.M)
    public Dialog onCreateDialog(Bundle savedInstanceState){
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        if(dialogTitle.equals(""))
            dialogTitle = getResources().getString(R.string.connect_button_wait);
        if(!addressList.isEmpty()) {
            boolean[] bool = new boolean[checkedItemsList.size()];
            for (int i = 0; i < checkedItemsList.size(); ++i) {
                bool[i] = checkedItemsList.get(i);
            }
            builder.setMultiChoiceItems(addressList.toArray(new String[0]), bool, new DialogInterface.OnMultiChoiceClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which, boolean isChecked) {
                    checkedItemsList.set(which, isChecked);
                }
            }).setPositiveButton(R.string.connect_button_connect, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    ArrayList<String> queue = new ArrayList<>();
                    for(int i = 0; i < addressList.size(); ++i){
                        if(checkedItemsList.get(i) == true){
                            queue.add(deviceHolders.get(i).addressRight);
                        }
                    }
                    sender.createConnections(queue);
// TODO                    senderFile.createConnections(queue);
//                    senderMic.createConnections(queue);
                    Toast.makeText(getActivity(), R.string.connect_button_connect, Toast.LENGTH_LONG).show();
                }
            });
        }
        builder.setTitle(dialogTitle).setIcon(R.drawable.ic_launcher_background).setNegativeButton("Anuluj", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });
        builder.setCancelable(false);
        Dialog dialog = builder.create();
        switchDialogTitle();
        return dialog;
    }

}
