package com.example.kamizelka;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatDialogFragment;
import androidx.fragment.app.FragmentManager;

import java.io.File;

public class OpenFileDialog extends AppCompatDialogFragment {
    private FragmentManager fragmentManager;
    SenderFunctionalFile sender;

    public OpenFileDialog(FragmentManager fragmentManager, SenderFunctionalFile sender){
        this.fragmentManager = fragmentManager;
        this.sender = sender;
    }

    private String[] getFiles(File directoryPath){
        Log.d("BUTTON OPEN FILE", "Directory: " + directoryPath);
        File[] files = directoryPath.listFiles();
        String result[];
        if(files.length == 0){
            result = new String[1];
            result[0] = getResources().getString(R.string.openFile_button_no_files);
        }else{
            result = new String[files.length];
            for(int i = 0; i < files.length; ++i){
                result[i] = files[i].getName();
        }}
        return result;
    }

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        String[] fileList = getFiles(getActivity().getExternalFilesDir(null));
        builder.setItems((fileList), new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                if(sender == null || !sender.isConnectionOk()){
                    Toast.makeText(getActivity(), "Urządzenie nie połączono", Toast.LENGTH_SHORT).show();
                }else{
                    sender.openFile(requireActivity().getExternalFilesDir(null).toString() + '/' + fileList[which]);
        }}});
        builder.setCancelable(false);
        return builder.create();
    }
    public void show(){
        this.show(fragmentManager, "DeviceListDialog");
    }
}
