package com.example.kamizelka;

import android.bluetooth.BluetoothGattCharacteristic;
import android.os.Build;
import android.util.Log;

import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;

import java.util.ArrayList;
import java.util.Arrays;

public class SenderFunctionStop extends SenderFunctional{
	protected final static String TAG = "BLUETOOTH SENDER_STOP";
	private byte bytePWM[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	ArrayList<Integer> gattsI = new ArrayList<>();
	int gattsIIndex = 0;

	public SenderFunctionStop(AppCompatActivity active, BluetoothLEServiceSender sender){
		super(active, sender);
	}

	@Override
	public void stopPlaying() {
		gattsI.clear();
		isPlaying = false;
	}

	@RequiresApi(api = Build.VERSION_CODES.M)
	@Override
	public void startPlaying() {
		for (int i = 0; i < sender.addressesQueue.size(); ++i){
			gattsI.add(i);
		}
		sender.nextStep = gattsI.get(0);
		isPlaying = true;
		gattsIIndex = 0;
		nextStep();
	}

	@RequiresApi(api = Build.VERSION_CODES.M)
	@Override
	public void nextStep(){
		if(gattsI.isEmpty())
			return;
//		Log.d(TAG, " NextStep Mic");
		if(sender.nextStep >= sender.addressesQueue.size()){
			sender.nextStep = 0;
			if(isPlaying) {

		}}
		if(sender.nextStep >= sender.gatts.size()) {
			sender.makeNewConnection();
		}else{
//			Log.d(TAG, " state: " + gatts.get(nextStep).getState());
			switch (sender.gatts.get(sender.nextStep).getState()){
				case notReady:																					// Если устройство не соеденено.
					sender.makeNewConnection();
					break;
				case connected:																					// Если с устройством есть соединение.
					Log.d(TAG, "trying to write cher, next step : " + sender.nextStep);
					sender.gatts.get(sender.nextStep).playerCharacteristic.setValue(sender.bluetoothAdapter.getAddress());
					sender.gatts.get(sender.nextStep).gatt.writeCharacteristic(sender.gatts.get(sender.nextStep).playerCharacteristic);		// Записываем на него свой аддресс.
					break;
				case written:																					// Если аддресс уже записан.
					sender.gatts.get(sender.nextStep).gatt.readCharacteristic(sender.gatts.get(sender.nextStep).readyCharacteristic);		// Опрашиваем удалённое устройство, готово ли оно.
					break;
				case ready:																						// Если устройство нашло свой левыц канал и готово.
					if (!isPlaying){																			// Если пользователь ещё не открыл файл для проигрывания.
						for (GattHolder g : sender.gatts){														// Если какое - то устройство ещё не готово, значит не выходим из функции.
							if (!g.getState().equals(GattHolder.GattHolderState.ready)){
								incrementNextStep();
								nextStep();
								return;
							}}} else {																			// Если уже проигрываем музыку.
						Log.d(TAG, Arrays.toString(this.bytePWM));
						sender.gatts.get(sender.nextStep).dataCharacteristic.setValue(bytePWM);					// Передаём данные.
						sender.gatts.get(sender.nextStep).dataCharacteristic.setWriteType(BluetoothGattCharacteristic.WRITE_TYPE_NO_RESPONSE);
						sender.gatts.get(sender.nextStep).gatt.writeCharacteristic(sender.gatts.get(sender.nextStep).dataCharacteristic);
						gattsI.remove(gattsIIndex);
					}
					break;
				case disable:
			}
		}
		incrementNextStep();
	}

	private void incrementNextStep(){
		if(gattsI.isEmpty())
			return;
		++this.gattsIIndex;
		if(this.gattsIIndex >= gattsI.size())
			gattsIIndex = 0;
		sender.nextStep = gattsI.get(this.gattsIIndex);
	}
}
