package com.example.kamizelka;

import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

public abstract class SenderFunctional {

	protected final static String TAG = "BLUETOOTH SENDER";
	protected BluetoothLEServiceSender sender;
	protected TextView textNotification;
	protected boolean isPlaying = false;
	AppCompatActivity active;
	boolean nextStepLock = false;
	protected long time = 0;

	public SenderFunctional(AppCompatActivity active, BluetoothLEServiceSender sender){
		textNotification = active.findViewById(R.id.deviceStatus);
		this.active = active;
		this.sender = sender;
	}

	public boolean isConnectionOk(){
		return sender.isConnectionOk();
	}

	public abstract void stopPlaying();

	public abstract void startPlaying();

	public abstract void nextStep();

	protected void statusUpdate() {
		int i = 0;
		for(GattHolder g : sender.gatts)
			if(g.state.equals(GattHolder.GattHolderState.ready))
				++i;
		if(i > 0) {
			this.textNotification.setText(R.string.device_status_text_view_connected);
			this.textNotification.setText(this.textNotification.getText() + " " + i);
			sender.isConnectionOk = true;
		}
		else
			this.textNotification.setText(R.string.device_status_text_view_disconnected);
		// TODO Удобное место для того, чтобы рестартовать прогресс.
	}
}
