package com.example.kamizelka;

import android.bluetooth.BluetoothGattCharacteristic;
import android.os.Handler;
import android.os.Looper;
import android.os.SystemClock;
import android.util.Log;
import android.widget.Button;

import androidx.appcompat.app.AppCompatActivity;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;

public class SenderFunctionalFile extends SenderFunctional{
	protected final static String TAG = "BLUETOOTH SENDER_File";
	ArrayList<byte[]> data = new ArrayList<>();
	OpenFileDialog openDialogfragment = null;
	int dataIndex = Integer.MAX_VALUE;
	Button buttonOpenFile;

	public SenderFunctionalFile(AppCompatActivity active, BluetoothLEServiceSender sender){
		super(active, sender);
		buttonOpenFile = active.findViewById(R.id.openFile);
	}

	@Override
	public void startPlaying() {
		isPlaying = true;
		if(openDialogfragment != null)
			openDialogfragment.dismiss();
		openDialogfragment = new OpenFileDialog(this.active.getSupportFragmentManager(), this);
		openDialogfragment.show();
	}

	@Override
	public void stopPlaying(){
		// TODO переделать отправление сигнала выключения напрямую.
		buttonOpenFile.setText(R.string.openFile_button_text_open);
		dataIndex = data.size() - 2;
		sender.nextStep = 0;
		isPlaying = false;
		nextStep();
	}

	@Override
	public void nextStep(){
		boolean bFlag = false;
		Log.d(TAG, " NextStep File, nextStep: " + sender.nextStep + " queue size: " + sender.addressesQueue.size());
		if(sender.nextStep >= sender.addressesQueue.size()){
			sender.nextStep = 0;
			if(isPlaying){
				++dataIndex;
				Log.d(TAG, "Data index = " + dataIndex + " size: " + data.size());
				if(dataIndex >= data.size()){
					isPlaying = false;
					sender.nextStep = 0;
					dataIndex = 0;
					return;
				}else{
					if(SystemClock.uptimeMillis() - time < Defines.SEND_FILE_PERIOD_MS){
						--dataIndex;
						for(int i = 0; i < sender.gatts.size(); ++i){												// Если какое - то устройство ещё не готово, значит не выходим из функции.
							if (!sender.gatts.get(i).getState().equals(GattHolder.GattHolderState.ready)){
								nextStepLock = true;
								sender.nextStep = i;
								nextStep();
								return;
						}}
						Log.d(TAG, "time = " + (Defines.SEND_MIC_PERIOD_MS - (SystemClock.uptimeMillis() - time)));
						++dataIndex;
						final Handler handler = new Handler(Looper.getMainLooper());
						handler.postDelayed(new Runnable(){
							@Override
							public void run(){
								nextStepLock = false;
								sender.nextStep = sender.addressesQueue.size();
							}
						}, Defines.SEND_FILE_PERIOD_MS - (SystemClock.uptimeMillis() - time));
						return;
		}}}}
		Log.d(TAG, "Next step, address number: " + sender.nextStep + ", gatts size: " + sender.gatts.size() + ", isPlaying: " + isPlaying + ", data index: " + dataIndex + " / " + data.size());
		if(sender.nextStep >= sender.gatts.size()) {
			sender.makeNewConnection();
		}else{
			Log.d(TAG, " state: " + sender.gatts.get(sender.nextStep).getState());
			switch (sender.gatts.get(sender.nextStep).getState()){
				case notReady:																					// Если устройство не соеденено.
					// TODO что будет, если устройств больше семи?
					// TODO this.textNotification.setText(R.string.device_status_text_view_inProgress);
					sender.makeNewConnection();
					break;
				case connected:																					// Если у устройством есть соединение.
					Log.d(TAG, "trying to write cher");
					sender.gatts.get(sender.nextStep).playerCharacteristic.setValue(sender.bluetoothAdapter.getAddress());
					sender.gatts.get(sender.nextStep).gatt.writeCharacteristic(sender.gatts.get(sender.nextStep).playerCharacteristic);		// Записываем на него свой аддресс.
					break;
				case written:																					// Если аддресс уже записан.
					sender.gatts.get(sender.nextStep).gatt.readCharacteristic(sender.gatts.get(sender.nextStep).readyCharacteristic);		// Опрашиваем удалённое устройство, готово ли оно.
					break;
				case ready:																						// Если устройство нашло свой левыц канал и готово.
					if (!isPlaying){																			// Если пользователь ещё не открыл файл для проигрывания.
						for (GattHolder g : sender.gatts){														// Если какое - то устройство ещё не готово, значит не выходим из функции.
							if (!g.getState().equals(GattHolder.GattHolderState.ready)){
								++sender.nextStep;
								nextStep();
								return;
							}}} else {																			// Если уже проигрываем музыку.
						bFlag = true;
						/*
						if(sender.nextStep == sender.gatts.size() - 1){
							new Handler(Looper.getMainLooper()).postDelayed(new Runnable() {
								@Override
								public void run() {																// Останавливаем сканирование через определённое время.
									nextStep();
								}}, Defines.SEND_FILE_PERIOD_MS);
							return;
						}
						*/

						sender.gatts.get(sender.nextStep).dataCharacteristic.setValue(data.get(dataIndex));		// Передаём данные.
						try {
							sender.gatts.get(sender.nextStep).dataCharacteristic.setWriteType(BluetoothGattCharacteristic.WRITE_TYPE_NO_RESPONSE);
						}catch(Exception e){
							Log.w(TAG, "ERROR: " + e.toString());
							sender.nextStep = 0;
						}
						sender.gatts.get(sender.nextStep).gatt.writeCharacteristic(sender.gatts.get(sender.nextStep).dataCharacteristic);
					}
					break;
				case disable:
			}
		}
		if(nextStepLock) {
			Log.w(TAG, "nextStepLock");
			sender.nextStep = sender.addressesQueue.size();
			nextStepLock = false;
		} else {
			Log.w(TAG, "++nextStep, " + sender.nextStep);
			if(sender.nextStep == 0) {
				time = SystemClock.uptimeMillis();
				Log.w(TAG, "upgrade time to: , " + SystemClock.uptimeMillis());

			}
			++sender.nextStep;
		}

		if(((sender.nextStep - 1) == sender.gatts.size() - 1) && bFlag){
			bFlag = false;
			new Handler(Looper.getMainLooper()).postDelayed(new Runnable() {
				@Override
				public void run() {																// Останавливаем сканирование через определённое время.
					nextStep();
				}}, Defines.SEND_FILE_PERIOD_MS);
			return;
		}
	}

	public void openFile(String fileName){
		try {
			BufferedReader bufferedReader = new BufferedReader(new FileReader(fileName));
			String line;
			while (true) {
				if ((line = bufferedReader.readLine()) == null) {
					Log.d(TAG, "Loop break");
					break;
				}
				byte bytePWM[] = new byte[16];
				StringBuilder string = new StringBuilder(line);
				string.delete(0, string.indexOf(" ") + 1);
				int motorNumber = Integer.parseInt(string.substring(0, string.indexOf(" "))) & 0xF;
				if(motorNumber > 7)		// TODO Это переложение количества моторчиков на 13 и исправление ошибочной нумерации.
					motorNumber += 3;
				if(motorNumber > 15)
					motorNumber = 15;
				string.delete(0, string.indexOf(" ") + 1);
				for(int iii = 0; iii < 16; ++iii){
					bytePWM[iii] = (byte) 0x00;
				}
				bytePWM[motorNumber] = (byte)(Integer.parseInt(string.toString()) * 10);//& 0xF);
				data.add((bytePWM));
				Log.d(TAG, Arrays.toString(bytePWM));
			}
			byte bytePWM[] = new byte[16];
			for(int iii = 0; iii < 16; ++iii){
				bytePWM[iii] = (byte) 0x00;
			}
			data.add(bytePWM);
			Log.d(TAG, Arrays.toString(bytePWM));
		} catch(IOException e){
			e.printStackTrace();
		} catch(IllegalArgumentException e){
			System.out.println("Exception throws: " + e);
		}
		dataIndex = -1;
		sender.nextStep = sender.addressesQueue.size();
//		isPlaying = true;
		buttonOpenFile.setText(R.string.openFile_button_text_stop);
		nextStep();
	}
}
