package com.example.kamizelka;

import android.annotation.SuppressLint;
import android.bluetooth.BluetoothGattCharacteristic;
import android.os.Build;
import android.os.SystemClock;
import android.util.Log;

import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;

import java.util.Arrays;

public class SenderFunctionalKeyboard extends SenderFunctional{
	protected final static String TAG = "BLUETOOTH SENDER_KEYBOARD";
	private byte bytePWM[] = new byte[16];

	public SenderFunctionalKeyboard(AppCompatActivity active, BluetoothLEServiceSender sender) {
		super(active, sender);
	}

	public void setbytePWM(int index, byte value){
		for(int i = 0; i < 16; ++i)
			bytePWM[i] = 0;
		bytePWM[index] = value;
	}

	@Override
	public void stopPlaying() {
		isPlaying = false;
	}

	@RequiresApi(api = Build.VERSION_CODES.M)
	@Override
	public void startPlaying() {
		isPlaying = true;
		sender.nextStep = 0;
		nextStep();
	}

	@SuppressLint("LongLogTag")
	@RequiresApi(api = Build.VERSION_CODES.M)
	@Override
	public void nextStep(){
//		Log.d(TAG, " NextStep Mic");
		if(sender.nextStep >= sender.addressesQueue.size()){
			sender.nextStep = 0;
			if(isPlaying){
//				Log.d(TAG, " is playing");
				if(SystemClock.uptimeMillis() - time < Defines.SEND_FILE_PERIOD_MS){
					for(int i = 0; i < sender.gatts.size(); ++i){												// Если какое - то устройство ещё не готово, значит не выходим из функции.
						if (!sender.gatts.get(i).getState().equals(GattHolder.GattHolderState.ready)){
							nextStepLock = true;
							sender.nextStep = i;
							nextStep();
						}}
					isPlaying = false;
					return;
		}}}
//		Log.d(TAG, " NextStepMic, next step: "+ sender.nextStep + " addressesQueue.size: " + sender.addressesQueue.size());
		if(sender.nextStep >= sender.gatts.size()) {
			sender.makeNewConnection();
		}else{
//			Log.d(TAG, " state: " + gatts.get(nextStep).getState());
			switch (sender.gatts.get(sender.nextStep).getState()){
				case notReady:																					// Если устройство не соеденено.
					sender.makeNewConnection();
					break;
				case connected:																					// Если у устройством есть соединение.
					Log.d(TAG, "trying to write cher, next step : " + sender.nextStep);
					sender.gatts.get(sender.nextStep).playerCharacteristic.setValue(sender.bluetoothAdapter.getAddress());
					sender.gatts.get(sender.nextStep).gatt.writeCharacteristic(sender.gatts.get(sender.nextStep).playerCharacteristic);		// Записываем на него свой аддресс.
					break;
				case written:																					// Если аддресс уже записан.
					sender.gatts.get(sender.nextStep).gatt.readCharacteristic(sender.gatts.get(sender.nextStep).readyCharacteristic);		// Опрашиваем удалённое устройство, готово ли оно.
					break;
				case ready:																						// Если устройство нашло свой левыц канал и готово.
					if (!isPlaying){																			// Если пользователь ещё не открыл файл для проигрывания.
						for (GattHolder g : sender.gatts){														// Если какое - то устройство ещё не готово, значит не выходим из функции.
							if (!g.getState().equals(GattHolder.GattHolderState.ready)){
								++sender.nextStep;
								nextStep();
								return;
					}}} else {																					// Если уже проигрываем музыку.
						Log.d(TAG, Arrays.toString(this.bytePWM));
						sender.gatts.get(sender.nextStep).dataCharacteristic.setValue(bytePWM);					// Передаём данные.
						try {
							sender.gatts.get(sender.nextStep).dataCharacteristic.setWriteType(BluetoothGattCharacteristic.WRITE_TYPE_NO_RESPONSE);
						}catch(Exception e){
						Log.w(TAG, "ERROR: " + e.toString());
						sender.nextStep = 0;
						}
						sender.gatts.get(sender.nextStep).gatt.writeCharacteristic(sender.gatts.get(sender.nextStep).dataCharacteristic);
					}
					break;
				case disable:
			}
		}
		if(nextStepLock) {
			sender.nextStep = sender.addressesQueue.size();
			nextStepLock = false;
		}else {
			if(sender.nextStep == 0)
				time = SystemClock.uptimeMillis();
			++sender.nextStep;
		}
	}
}
