package com.example.kamizelka;

import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;
import android.util.Log;

import java.util.Arrays;

public class ToneGenerator {
	final int sampleRate = 48000;  // 44100 Hz
	final int durationMs = Defines.KEYBOARD_SOUND_DURATION_MS;
	int count = (int)( sampleRate * (durationMs / 1000.0)) & ~1;
	AudioTrack track = new AudioTrack(AudioManager.STREAM_MUSIC, sampleRate, AudioFormat.CHANNEL_OUT_MONO, AudioFormat.ENCODING_PCM_16BIT,
			count * (Short.SIZE / 8), AudioTrack.MODE_STATIC);

	public void generateTone(double freqHz){
		short[] samples = new short[count];
		for(int i = 0; i < count; i += 1){
			short sample = (short)(2 * Math.asin(Math.sin(2 * Math.PI * i / (sampleRate / freqHz))) * 0x7FFF / Math.PI);
//			short sample = (short)(Math.sin(2 * Math.PI * i / (sampleRate / freqHz)) * 0x7FFF);
			samples[i + 0] = sample;
		}
//		Log.d("SAMPLE", "" + freqHz);
//		Log.d("SAMPLE", Arrays.toString(samples));
		if(track.getState() == AudioTrack.STATE_INITIALIZED)
			track.stop();
		track.write(samples, 0, count);
		track.play();
	}

	public void delete(){
		this.track.flush();
		this.track.stop();
		this.track.release();
	}
}
