/*
 * helpers.h
 *
 *  Created on: 14 kwi 2021
 *      Author: Kashey
 */

#ifndef MAIN_HELPERS_H_
#define MAIN_HELPERS_H_

// Инициализация библиотеки энергонезависимой памяти.
inline void hFlashInit(esp_err_t ret){
	if (ret == ESP_ERR_NVS_NO_FREE_PAGES || ret == ESP_ERR_NVS_NEW_VERSION_FOUND) {
		ESP_ERROR_CHECK(nvs_flash_erase());
		ret = nvs_flash_init();
	}
	ESP_ERROR_CHECK(ret);
}

inline void hCheckErr(esp_err_t ret, const char* str, const char* h__func__){
	if (ret) {
		ESP_LOGE(GATTC_TAG, "%s, %s: %s\n", h__func__, str, esp_err_to_name(ret));
		return;
}}

void hCheckErr2(esp_err_t ret, char* str){
	if (ret) {
		ESP_LOGE(GATTC_TAG, "%s, error code = %x", str, ret);
		return;
}}

static bool compareUUID(uint8_t* a, uint8_t* b){
		for(int i = 0; i < ESP_UUID_LEN_128; ++i){
			if(a[i] != b[i])
				return false;
		}
	return true;
}

static void printBoofer(const char* tag, const char* str, uint8_t* boofer, const size_t size){
	ESP_LOGI(tag, "%s", str);
	esp_log_buffer_hex(tag, boofer, size);

}

static void logDisconnect(const char* tag, const char* str, esp_bd_addr_t bda){
	ESP_LOGI(tag, "%s", str);
	esp_ble_gap_disconnect(bda);
}

#endif /* MAIN_HELPERS_H_ */
