/*
 * timer.h
 *
 *  Created on: 6 cze 2021
 *      Author: Kashey
 */

#ifndef TIMER_H_
#define TIMER_H_

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "esp_timer.h"
#include "esp_log.h"
#include "esp_sleep.h"
#include "sdkconfig.h"

static void periodic_timer_callback(void* arg);

static const char* TAG = "TIMER";

void startTimer(void){
    const esp_timer_create_args_t periodic_timer_args = {
            .callback = &periodic_timer_callback,
            /* name is optional, but may help identify the timer when debugging */
            .name = "periodic"
    };
    esp_timer_handle_t periodic_timer;
    ESP_ERROR_CHECK(esp_timer_create(&periodic_timer_args, &periodic_timer));
    ESP_ERROR_CHECK(esp_timer_start_periodic(periodic_timer, 5000000));
    ESP_LOGI(TAG, "Started timers, time since boot: %lld us", esp_timer_get_time());

}

static void periodic_timer_callback(void* arg){
//	if((transmissionTimer - esp_timer_get_time()) > 5000000) {
//	    ESP_LOGW(TAG, "Allert, Transmission time too far, disconnect. Last transmission: %lld ", transmissionTimer);
//	}
//    int64_t time_since_boot = esp_timer_get_time();
//    ESP_LOGI(TAG, "Periodic timer called, time since boot: %lld us", time_since_boot);
}


#endif /* TIMER_H_ */
