#include "DeviceHolder.h"

DeviceHolder::DeviceHolder(uint64_t bleAddress){
    this->setAddress(bleAddress);
}

void DeviceHolder::setAddress(uint64_t bleAddress) {
    this->bleAddress = bleAddress;
}

void DeviceHolder::setValues(winrt::guid uuid, uint8_t* rawData, uint8_t dataSize) {
    std::stringstream str;
    str << std::hex << std::setfill('0') << std::setw(8) << uuid.Data1 << "-";
    str << std::hex << std::setfill('0') << std::setw(4) << uuid.Data2 << "-";
    str << std::hex << std::setfill('0') << std::setw(4) << uuid.Data3 << "-";
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[0];
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[1] << "-";
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[2];
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[3];
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[4];
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[5];
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[6];
    str << std::hex << std::setfill('0') << std::setw(2) << (int)uuid.Data4[7];
    setValues(str.str(), rawData, dataSize);
}

void DeviceHolder::setValues(std::string string, uint8_t* rawData, uint8_t dataSize) {
    std::string str;
    for (int i = 0; i < dataSize; ++i)
        str += (char)rawData[i];
    if (string == (DeviceHolder::serialNumberCharacteristicUUID))
        this->serialNumber = str;
    if (string == (DeviceHolder::channelCharacteristicUUID))
        this->channel = str;
    if (string == (DeviceHolder::authorCharacteristicUUID))
        this->author = str;
    if (string == (DeviceHolder::technicalImplementationCharacteristicUUID))
        this->technicalImplementation = str;
    if (string == (DeviceHolder::deviceVersionCharacteristicUUID))
        this->deviceVersion = str;
    if (string == (DeviceHolder::deviceNameCharacteristicUUID))
        this->deviceName = str;
    if (string == (DeviceHolder::transferCharacteristicUUID))
        this->transferDevice = str;
    if (string == (DeviceHolder::playerCharacteristicUUID))
        this->playerDevice = str;
    if (string == (DeviceHolder::leftChannelCharacteristicUUID))
        this->leftChannelDevice = str;
    if (string == (DeviceHolder::readyCharacteristicUUID))
        this->ready = str;
}