#pragma once
#include <string>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <winrt/base.h>
class DeviceHolder{
public:
    uint64_t bleAddress;

    std::string addressRight;
    std::string addressLeft;
    std::string serialNumber;
    std::string channel;
    std::string author;
    std::string technicalImplementation;
    std::string deviceVersion;
    std::string deviceName;
    std::string transferDevice;
    std::string playerDevice;
    std::string leftChannelDevice;
    std::string ready;

    DeviceHolder(uint64_t bleAddress);
    void setValues(std::string string, uint8_t* rawData, uint8_t dataSize);
    void setValues(winrt::guid uuid, uint8_t* rawData, uint8_t dataSize);
    void setAddress(uint64_t bleAddress);

    inline static const std::string infoServiceUUID = "58476dd0-cc53-4ae0-9a84-05c0c0e02419";
    inline static const std::string serialNumberCharacteristicUUID = "58476dd1-cc53-4ae0-9a84-05c0c0e02419";
    inline static const std::string channelCharacteristicUUID = "58476dd3-cc53-4ae0-9a84-05c0c0e02419";
    inline static const std::string authorCharacteristicUUID = "58476dd5-cc53-4ae0-9a84-05c0c0e02419";
    inline static const std::string technicalImplementationCharacteristicUUID = "58476dd7-cc53-4ae0-9a84-05c0c0e02419";
    inline static const std::string deviceVersionCharacteristicUUID = "58476dd9-cc53-4ae0-9a84-05c0c0e02419";
    inline static const std::string deviceNameCharacteristicUUID = "58476ddb-cc53-4ae0-9a84-05c0c0e02419";
    inline static const std::string dataServiceUUID = "07803df7-c740-4c4b-b7a5-bae89e59a0f2";
    inline static const std::string dataCharacteristicUUID = "07803df8-c740-4c4b-b7a5-bae89e59a0f2";
    inline static const std::string transferCharacteristicUUID = "07803dfb-c740-4c4b-b7a5-bae89e59a0f2";
    inline static const std::string playerCharacteristicUUID = "07803dfd-c740-4c4b-b7a5-bae89e59a0f2";
    inline static const std::string leftChannelCharacteristicUUID = "07803df5-c740-4c4b-b7a5-bae89e59a0f2";
    inline static const std::string readyCharacteristicUUID = "07803df3-c740-4c4b-b7a5-bae89e59a0f2";
    inline static const std::string remoteDeviceName = "Kamizelka"; //"ESP_GATTS_DEMO"
};

