#pragma once
#include <vector>
#include <wx/wx.h>
#include "Keyboard.h"
#include "BLEScanner.h"
#include "DeviceListDialog.h"

class MainWindow : public wxFrame {
public:
	wxStaticText* deviceStatus;
	wxButton* connectButton;
	wxButton* openFileButton;
	wxButton* microphoneButton;
	wxButton* keyboardButton;
	Keyboard* keyboard;

	std::vector<DeviceHolder>* devices;

	void onResize(wxSizeEvent& event);
	void onClickConnectButton(wxCommandEvent& WXUNUSED (event));
	void onClickOpenFileButton(wxCommandEvent& WXUNUSED (event));
	void onClickMicrophoneButton(wxCommandEvent& WXUNUSED (event));
	void onClickKeyboardButton(wxCommandEvent& WXUNUSED (event));
	void warpText(int width);
	void CloseIt(wxCloseEvent& event);
	static MainWindow& getInstance();
	void initialize();
	bool Show(bool);
private:
	MainWindow();
	MainWindow& operator=(MainWindow&);
};